import processing.sound.*;

int x = 0; // x position ball
int y = 0; // y position ball
int w = 40; // width position ball
int h = 40; // height position ball

int speedX = 3; // speed of the ball over X
int speedY = 3; // speed of the ball over y

int pX = 0; // x position ball
int pY = 0; // y position ball
int pW = 40; // width position ball
int pH = 150; // height position ball

SoundFile plop; // sound effect for ball hitting a wall
SoundFile beeep; // sound effect for ball hitting the paddle
SoundFile peeeeeep; // sound when we loose

PFont rosesare; // nice font

boolean playing = true; // becomes false when we loose

int counter = 0;

void setup() {
  size(500, 400);
 
  x = w / 2; // set the x position of the ball  
  y = h / 2 + 100; // set the y position of the ball

  // Load a soundfile
  plop = new SoundFile(this, "ping_pong_8bit_plop_01.wav");
  beeep = new SoundFile(this, "ping_pong_8bit_beeep_01.wav");
  peeeeeep = new SoundFile(this, "ping_pong_8bit_peeeeeep_01.wav");

  // Load font
  rosesare = createFont("RosesareFF0000.ttf", 30);
  textFont(rosesare);

  pX = width - pW;
  pY = 0;

  //soundfile.play();
}

void reset() {
  x = w / 2; // set the x position of the ball 

  y = (int)random(h/2, height - h/2) ; // set the y position of the ball
  //y = h / 2 ; // set the y position of the ball
  
  counter = 0;
}


void draw() {
  background(0); // draw a black background
  fill(255); // use white for drawing

  text(counter, width/2, 30);

  if (playing == true) {

    pY = mouseY; // position paddle on mouse Y

    rect(pX, pY, pW, pH);


    x = x + speedX; // update speed over X
    y = y + speedY; // update speed over Y


    // bounce x 
    if (x + w/2 > width - pW) {

      if (y > pY && y < pY + pH) {
        //We hit the paddle
        speedX = speedX * -1;
        beeep.play();
        counter = counter + 1;
        
      } else {
        // We loose
        println("fail");
        peeeeeep.play();
        playing = false;
      }
    }

    if (x - w/2 < 0) {
      speedX = speedX * -1;
      plop.play();
    }


    // bounce y 
    if (y + h/2 > height || y - h/2 < 0) {
      speedY = speedY * -1;
      plop.play();
    }

    ellipse(x, y, w, h); // draw circle
  }
}

void keyPressed() {
  if (key == ' ') {
    reset();
    playing = true;
  }
}